package com.mooctest.dao;

import com.mooctest.model.SupplementItem;
import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface SupplementDao extends MongoRepository<SupplementItem, Long> {

    List<SupplementItem> findByMasterId(String masterId);

    List<SupplementItem> findBySupplementId(String supId);

    List<SupplementItem> findByMasterIdIn(List<String> masterIds);

    void deleteByMasterIdIn(List<String> masterIds);
}
