package com.mooctest.model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Document(collection = "bug")
public class Bug {

    @Id
    private String id;

    @Field("case_take_id")
    private String caseTakeId;

    @Field("report_id")
    private String reportId;

    private String description;

    @Field("img_url")
    private String imgUrls;

    private short severity;

    private short recurrent;

    @Field("bug_category")
    private String bugCategory;

    @Field("create_time_millis")
    private String createTimeMillis;

    @Field("bug_page")
    private String bugPage;

    @Field("case_id")
    private String caseId;
}
